;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
PRO fourierselectfilter_event, event

  widget_control, event.id, get_uvalue = uvalue
  widget_control, event.top, get_uvalue=obj

  case uvalue of 
    'FILTER' : obj->filterselect, event, uvalue
    'apply'  : obj->quit, event, uvalue
  endcase
end

PRO fourierselectfilter::quit, event, uvalue
;  COMMON passing, bid, eid, sid, dt, N_k, N_m, r0, dr0, st, st1, time, choice
  common choice
  common filter, ownfilter
  
  if choice eq 2 then begin
    widget_control, widget_info(event.top, find_by_uname="ownfilter"), $
        get_value=ownfilter
  endif
  widget_control, event.top, /destroy

end

PRO fourierselectfilter::filterselect,event, uvalue

common filter, ownfilter

  COMMON setupvariables
;  COMMON passing, bid, eid, sid, dt, N_k, N_m, r0, dr0, st, st1, time, choice
  common choice
  COMMON fourier_data, rr, kk, mmm, a, a_cut 

  Widget_Control, event.top, Get_UValue=droplists
  thisEvent = Tag_Names(event, /Structure_Name)  
  thisDroplist = event.self->GetUValue()
  IF *event.selection eq 'Sin-square' THEN begin
    choice = 0   
    widget_control, widget_info(event.top, find_by_uname="ownfilter"), $
        sensitive=0
  endif
  IF *event.selection eq 'Gaussian' THEN begin
    choice = 1     
    widget_control, widget_info(event.top, find_by_uname="ownfilter"), $
        sensitive=0
  endif
  IF *event.selection eq 'Add your own' THEN begin
    choice = 2   
    widget_control, widget_info(event.top, find_by_uname="ownfilter"), $
        sensitive=1
  ENDIF

END
   

function fourierselectfilter::init

status = self->tool::init('fourierselectfilter',/nowindow)

  filterlist = ['Sine-square','Gaussian','Add your own']
  droplist = FSC_Droplist(self.inbase, Value=filterlist, Index=0, UValue='FILTER',title='Filter Function')
  ownfilter = cw_field(self.inbase, uname="ownfilter", uvalue="ownfilter", $ 
              title="Filter: ")
  closeButton = Widget_Button(self.inbase, Value='Apply', uvalue="apply")

  widget_control, self.base, /update
  widget_control, ownfilter, sensitive=0
;  self->resize
  return, 1

end

pro fourierselectfilter__define

void = {fourierselectfilter, inherits tool}

end
