;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
function polint, y, x, n, sorted = sorted

   i = fltarr(n+1,n+1)
   nsa = round(x)
   ia = fltarr(n_elements(nsa))

   for t=0, n_elements(nsa)-1 do begin
      if not(keyword_set(sorted)) then begin
         ns = nsa[t]
         if (ns > x[t]) then begin
            mink = fix(ns-ceil(0.5*(n+1)))
            maxk = ns+floor(0.5*(n+1))-1
;            print, "ugh1", mink, maxk, ns, n, x[t]
        end else begin
           mink = fix(ns-floor(0.5*(n+1)))
           maxk = ns+ceil(0.5*(n+1))-1
;            print, "ugh2", mink, maxk
       end
    end else begin
       mink = 0
       maxk = n
;            print, "ugh3", mink, maxk
   end
 
 mink = max([mink,0])
 maxk = max([maxk,n])

 mink = min([mink, n_elements(y)-n-1])
 maxk = min([maxk, n_elements(y)-1])

; if mink gt maxk then print, mink, maxk, n_elements(y), n, t
 I(0,*) = y(mink:maxk)
 
 for j=1,n do begin
    for l=mink+j, maxk do begin
       k = l - mink
       I(j,k) = (I(j-1,k-1)*(l-x[t])+I(j-1,k)*(x[t]-mink))/(l-mink)
   end
end
 ia[t] = I(n,n)
endfor 
 return, ia
end
