;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
function polint3d, data, x1, x2, x3, n=n

   s=size(data)   
   m = n_elements(x1)
   tmpZ = fltarr(n+1,n+1,m)
   tmpY = fltarr(n+1,m)
   tmp = fltarr(m)
   
   i = where(round(x1) > x1)

   mini = fix(x1-floor(0.5*(n+1)))
   mini[i] = fix(round(round(x1[i]))-ceil(0.5*(n+1)))

   i = where(round(x2) > x2)

   minj = fix(x2-floor(0.5*(n+1)))
   minj[i] = fix(round(x2[i])-ceil(0.5*(n+1)))

   for ii=0, m-1 do begin
   mini[ii] = max([mini[ii],0])
   minj[ii] = max([minj[ii],0])
   mini[ii] = min([mini[ii],s[1]-n-2])
   minj[ii] = min([minj[ii],s[2]-n-2])
   endfor

   for g=0,m-1 do begin
      for i = 0, n do begin
         for j=0,n do begin
;            print, "g, i, j ", g, i, j
            tmpZ(i,j,*) = polint(reform(data(mini[g]+i,minj[g]+j,*)), x3[g], n)
        end
     end
      for i=0,n do $
         tmpY(i,*) = polint(reform(tmpZ(i, *)), x2[g] - minj[g], n, /sorted)
      tmp(g) = polint(tmpY, x1[g]-mini[g], n, /sorted)
  end
 return, tmp
end
