;###########################################################################
;
; LICENSE
;
; Copyright 2004 CAPCA at University of Calgary.
;
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;
;
; The newest version is available from http://www.capca.ucalgary.ca/software
;
;###########################################################################
;
; Routines used by several JETGET routines
; Written in the summer 2001
;
; To be accessed from JETGET
;

FUNCTION NumberFileName, Prefix, NID, Postfix, NIDLength=NIDLength
;
; Function for creating filenames of the form Prefix+NID+Postfix,
; where NID is converted to a string of length NIDLength
; Still under construction
;
  Default, Prefix, ''
  Default, Postfix, ''
  Default, NIDLength, 3  

  zerostring =""
  IF (NID LE 9) THEN BEGIN
    for i=1,nidlength-1 do $
      zerostring = zerostring+'0'
    Name = PreFix+zerostring+STRING(FORMAT = '(I1)',nid)+Postfix
  ENDIF ELSE BEGIN
    IF NID LE 99 THEN BEGIN
      for i=1,nidlength-2 do $
        zerostring=zerostring+'0'
      Name = Prefix+zerostring+STRING(FORMAT = '(I2)',nid)+Postfix
    ENDIF ELSE BEGIN
      for i = 1, nidlength-3 do $
        zerostring=zerostring+'0'
      Name = Prefix+zerostring+STRING(FORMAT = '(I3)',nid)+Postfix
    ENDELSE
  ENDELSE

  RETURN, Name
END

FUNCTION fileExists, file
;
; Check if the file with filename, file, exist
;
  ON_IOERROR, failed

  GET_LUN, lu
  OPENR,  lu, file
  FREE_LUN, lu

  RETURN, 1

  failed:
  RETURN, 0

END

PRO Default, Var, Val
;
; This procedure checks if Var has a value and 
; if not sets it to Val.
;
  IF N_ELEMENTS(Var) EQ 0 THEN Var = Val
END

PRO shared

END

FUNCTION CVT_TO_2D, X, Y, Z, T
  P = [X, Y, Z, 1] # T 
; Return the scaled result as a two-element,
; two-dimensional, xy vector: 
  RETURN, [P[0] / P[3], P[1] / P[3]]
;  RETURN, [P[1] / P[3], P[2] / P[3]]
END
